
#pragma once

#include <map>
#include <vector>
#include <string>

#include "cocos/scripting/js-bindings/jswrapper/SeApi.h"
#include "cocos/scripting/js-bindings/manual/jsb_conversions.hpp"
#include "cocos/scripting/js-bindings/manual/jsb_global.h"

namespace sdkbox {
    class JSListenerBase {
    public:
        void setJSDelegate(const se::Value& jsDelegate);
        const se::Value& getJSDelegate();

        void invokeJSFun(const std::string& funName, const se::ValueArray& params = se::EmptyValueArray);

    private:
        se::Value _JSDelegate;
    };
    
    se::Value getPluginVal(se::Object* obj, const std::string& name);
}
